require 'spec_helper'

describe BackupFoundation do
  describe '::store_app' do
    it 'saves app key and encryption ket' do
      BackupFoundation.store_app('asdf')
      expect(BackupFoundation.app_key).to eq('asdf')
    end
  end

  describe '::encrypt' do
    it 'saves ecryption key' do
      BackupFoundation.store_app('asdf') { encrypt 'qwer' }
      expect(BackupFoundation.encryption_key).to eq('qwer')
    end
  end

  describe '::backup_db' do
    it 'recognizes SQLite' do
      Rails.env = ActiveSupport::StringInquirer.new('sqlite')
      connect_active_record
      BackupFoundation.store_app('asdf') { backup_db }
      expect(BackupFoundation.items[0][:type]).to eq(:sqlite)
    end

    it 'recognizes PostgreSQL' do
      Rails.env = ActiveSupport::StringInquirer.new('postgresql')
      connect_active_record
      BackupFoundation.store_app('asdf') { backup_db }
      expect(BackupFoundation.items[0][:type]).to eq(:postgresql)
    end

    it 'recognizes MySQL' do
      Rails.env = ActiveSupport::StringInquirer.new('mysql')
      connect_active_record
      BackupFoundation.store_app('asdf') { backup_db }
      expect(BackupFoundation.items[0][:type]).to eq(:mysql)
    end
  end

  describe '::make_backup!'
  describe '::restore_backup!'
end
